diff --git a/lib/app/modules/warga/views/warga_view.dart b/lib/app/modules/warga/views/warga_view.dart
index c76e064..019623c 100644
--- a/lib/app/modules/warga/views/warga_view.dart
+++ b/lib/app/modules/warga/views/warga_view.dart
@@ -4,16 +4,28 @@ import 'package:penyaluran_app/app/modules/warga/controllers/warga_dashboard_con
 import 'package:penyaluran_app/app/modules/warga/views/warga_dashboard_view.dart';
 import 'package:penyaluran_app/app/modules/warga/views/warga_penerimaan_view.dart';
 import 'package:penyaluran_app/app/modules/warga/views/warga_pengaduan_view.dart';
-import 'package:penyaluran_app/app/widgets/app_drawer.dart';
 import 'package:penyaluran_app/app/widgets/app_bottom_navigation_bar.dart';
 import 'package:penyaluran_app/app/theme/app_theme.dart';
 
 class WargaView extends GetView<WargaDashboardController> {
-  const WargaView({super.key});
+  final GlobalKey<ScaffoldState> scaffoldKey = GlobalKey<ScaffoldState>();
+
+  WargaView({super.key});
 
   @override
   Widget build(BuildContext context) {
-    final GlobalKey<ScaffoldState> scaffoldKey = GlobalKey<ScaffoldState>();
+    // Tambahkan listener untuk refresh data saat fokus didapatkan kembali
+    // misalnya ketika kembali dari halaman profil
+    WidgetsBinding.instance.addPostFrameCallback((_) {
+      final focusNode = FocusNode();
+      FocusScope.of(context).requestFocus(focusNode);
+      focusNode.addListener(() {
+        if (focusNode.hasFocus) {
+          print('DEBUG WARGA: Halaman mendapatkan fokus, memuat ulang data');
+          controller.refreshData();
+        }
+      });
+    });
 
     return Scaffold(
       key: scaffoldKey,
@@ -81,40 +93,7 @@ class WargaView extends GetView<WargaDashboardController> {
           ),
         ],
       ),
-      drawer: Obx(() => AppDrawer(
-            nama: controller.nama,
-            role: 'Warga',
-            desa: controller.desa,
-            notificationCount: controller.jumlahNotifikasiBelumDibaca.value,
-            onLogout: controller.logout,
-            menuItems: [
-              DrawerMenuItem(
-                icon: Icons.dashboard_outlined,
-                title: 'Dashboard',
-                isSelected: controller.activeTabIndex.value == 0,
-                onTap: () => controller.changeTab(0),
-              ),
-              DrawerMenuItem(
-                icon: Icons.volunteer_activism_outlined,
-                title: 'Penerimaan',
-                isSelected: controller.activeTabIndex.value == 1,
-                onTap: () => controller.changeTab(1),
-              ),
-              DrawerMenuItem(
-                icon: Icons.report_problem_outlined,
-                title: 'Pengaduan',
-                isSelected: controller.activeTabIndex.value == 2,
-                badgeCount: controller.totalPengaduanProses.value,
-                badgeColor: Colors.orange,
-                onTap: () => controller.changeTab(2),
-              ),
-              DrawerMenuItem(
-                icon: Icons.description_outlined,
-                title: 'Laporan Penyaluran',
-                onTap: () => Get.toNamed('/laporan-penyaluran'),
-              ),
-            ],
-          )),
+      drawer: _buildDrawer(context),
       body: Obx(() {
         switch (controller.activeTabIndex.value) {
           case 0:
@@ -158,4 +137,276 @@ class WargaView extends GetView<WargaDashboardController> {
           )),
     );
   }
+
+  Widget _buildDrawer(BuildContext context) {
+    // Muat ulang data foto profil ketika drawer dibuka
+    WidgetsBinding.instance.addPostFrameCallback((_) {
+      if (controller.fotoProfil.isEmpty) {
+        controller.loadUserData();
+      }
+    });
+
+    return Drawer(
+      child: Column(
+        children: [
+          Container(
+            decoration: BoxDecoration(
+              gradient: AppTheme.primaryGradient,
+            ),
+            padding: EdgeInsets.only(
+                top: MediaQuery.of(context).padding.top + 16,
+                bottom: 24,
+                left: 16,
+                right: 16),
+            width: double.infinity,
+            child: Column(
+              crossAxisAlignment: CrossAxisAlignment.start,
+              children: [
+                Container(
+                  decoration: BoxDecoration(
+                    shape: BoxShape.circle,
+                    border: Border.all(color: Colors.white, width: 2),
+                    boxShadow: [
+                      BoxShadow(
+                        color: Colors.black.withOpacity(0.2),
+                        blurRadius: 10,
+                        offset: Offset(0, 5),
+                      ),
+                    ],
+                  ),
+                  child: CircleAvatar(
+                    radius: 40,
+                    backgroundColor: Colors.white70,
+                    backgroundImage: controller.profilePhotoUrl != null &&
+                            controller.profilePhotoUrl!.isNotEmpty
+                        ? NetworkImage(controller.profilePhotoUrl!)
+                        : null,
+                    child: controller.profilePhotoUrl == null ||
+                            controller.profilePhotoUrl!.isEmpty
+                        ? Icon(
+                            Icons.person,
+                            color: Colors.white,
+                            size: 40,
+                          )
+                        : null,
+                  ),
+                ),
+                SizedBox(height: 16),
+                Text(
+                  'Halo,',
+                  style: TextStyle(
+                    color: Colors.white70,
+                    fontSize: 16,
+                  ),
+                ),
+                Text(
+                  controller.nama,
+                  style: TextStyle(
+                    color: Colors.white,
+                    fontWeight: FontWeight.bold,
+                    fontSize: 22,
+                  ),
+                  overflow: TextOverflow.ellipsis,
+                  maxLines: 2,
+                ),
+                SizedBox(height: 4),
+                Row(
+                  mainAxisSize: MainAxisSize.min,
+                  children: [
+                    Container(
+                      padding: EdgeInsets.symmetric(horizontal: 8, vertical: 4),
+                      decoration: BoxDecoration(
+                        color: Colors.white.withOpacity(0.2),
+                        borderRadius: BorderRadius.circular(20),
+                      ),
+                      child: Text(
+                        'Warga',
+                        style: TextStyle(
+                          color: Colors.white,
+                          fontSize: 12,
+                        ),
+                      ),
+                    ),
+                    SizedBox(width: 8),
+                    Container(
+                      padding: EdgeInsets.symmetric(horizontal: 8, vertical: 4),
+                      decoration: BoxDecoration(
+                        color: Colors.white.withOpacity(0.2),
+                        borderRadius: BorderRadius.circular(20),
+                      ),
+                      child: Row(
+                        mainAxisSize: MainAxisSize.min,
+                        children: [
+                          Icon(
+                            Icons.location_on,
+                            color: Colors.white,
+                            size: 14,
+                          ),
+                          SizedBox(width: 4),
+                          Text(
+                            controller.desa ?? 'Tidak ada desa',
+                            style: TextStyle(
+                              color: Colors.white,
+                              fontSize: 12,
+                            ),
+                          ),
+                        ],
+                      ),
+                    ),
+                  ],
+                ),
+              ],
+            ),
+          ),
+          Expanded(
+            child: ListView(
+              padding: EdgeInsets.zero,
+              children: [
+                _buildMenuCategory('Menu Utama'),
+                Obx(() => _buildMenuItem(
+                      icon: Icons.dashboard_outlined,
+                      activeIcon: Icons.dashboard,
+                      title: 'Dashboard',
+                      isSelected: controller.activeTabIndex.value == 0,
+                      onTap: () {
+                        Navigator.pop(context);
+                        controller.changeTab(0);
+                      },
+                    )),
+                Obx(() => _buildMenuItem(
+                      icon: Icons.volunteer_activism_outlined,
+                      activeIcon: Icons.volunteer_activism,
+                      title: 'Penerimaan',
+                      isSelected: controller.activeTabIndex.value == 1,
+                      onTap: () {
+                        Navigator.pop(context);
+                        controller.changeTab(1);
+                      },
+                    )),
+                Obx(() => _buildMenuItem(
+                      icon: Icons.report_problem_outlined,
+                      activeIcon: Icons.report_problem,
+                      title: 'Pengaduan',
+                      isSelected: controller.activeTabIndex.value == 2,
+                      badge: controller.totalPengaduanProses.value > 0
+                          ? controller.totalPengaduanProses.value.toString()
+                          : null,
+                      onTap: () {
+                        Navigator.pop(context);
+                        controller.changeTab(2);
+                      },
+                    )),
+                _buildMenuCategory('Pengaturan'),
+                _buildMenuItem(
+                  icon: Icons.person_outline,
+                  activeIcon: Icons.person,
+                  title: 'Profil',
+                  onTap: () async {
+                    Navigator.pop(context);
+                    await Get.toNamed('/profile');
+                    // Refresh data ketika kembali dari profil
+                    controller.refreshData();
+                  },
+                ),
+                _buildMenuItem(
+                  icon: Icons.logout,
+                  title: 'Keluar',
+                  onTap: () {
+                    Navigator.pop(context);
+                    controller.logout();
+                  },
+                  isLogout: true,
+                ),
+              ],
+            ),
+          ),
+          Padding(
+            padding: const EdgeInsets.symmetric(horizontal: 16, vertical: 8),
+            child: Text(
+              'Â© ${DateTime.now().year} Aplikasi Penyaluran Bantuan',
+              style: TextStyle(
+                fontSize: 12,
+                color: Colors.grey,
+              ),
+              textAlign: TextAlign.center,
+            ),
+          ),
+        ],
+      ),
+    );
+  }
+
+  Widget _buildMenuCategory(String title) {
+    return Padding(
+      padding: const EdgeInsets.only(left: 16, right: 16, top: 16, bottom: 8),
+      child: Text(
+        title,
+        style: TextStyle(
+          fontSize: 12,
+          fontWeight: FontWeight.bold,
+          color: Colors.grey[600],
+        ),
+      ),
+    );
+  }
+
+  Widget _buildMenuItem({
+    required IconData icon,
+    IconData? activeIcon,
+    required String title,
+    bool isSelected = false,
+    String? badge,
+    required Function() onTap,
+    bool isLogout = false,
+  }) {
+    return AnimatedContainer(
+      duration: Duration(milliseconds: 200),
+      decoration: BoxDecoration(
+        color: isSelected
+            ? AppTheme.primaryColor.withOpacity(0.1)
+            : Colors.transparent,
+        borderRadius: BorderRadius.circular(8),
+      ),
+      margin: EdgeInsets.symmetric(horizontal: 8, vertical: 2),
+      child: ListTile(
+        leading: Icon(
+          isSelected ? (activeIcon ?? icon) : icon,
+          color: isSelected
+              ? AppTheme.primaryColor
+              : (isLogout ? Colors.red : null),
+        ),
+        title: Text(
+          title,
+          style: TextStyle(
+            color: isSelected
+                ? AppTheme.primaryColor
+                : (isLogout ? Colors.red : null),
+            fontWeight: isSelected ? FontWeight.bold : null,
+          ),
+        ),
+        trailing: badge != null
+            ? Container(
+                padding: EdgeInsets.symmetric(horizontal: 6, vertical: 2),
+                decoration: BoxDecoration(
+                  color: Colors.orange,
+                  borderRadius: BorderRadius.circular(10),
+                ),
+                constraints: BoxConstraints(
+                  minWidth: 20,
+                  minHeight: 20,
+                ),
+                child: Text(
+                  badge,
+                  style: TextStyle(
+                    color: Colors.white,
+                    fontSize: 12,
+                  ),
+                  textAlign: TextAlign.center,
+                ),
+              )
+            : null,
+        onTap: onTap,
+      ),
+    );
+  }
 }
diff --git a/lib/app/routes/app_pages.dart b/lib/app/routes/app_pages.dart
index 562f510..7de0bd5 100644
--- a/lib/app/routes/app_pages.dart
+++ b/lib/app/routes/app_pages.dart
@@ -57,7 +57,7 @@ class AppPages {
     ),
     GetPage(
       name: Routes.wargaDashboard,
-      page: () => const WargaView(),
+      page: () => WargaView(),
       binding: WargaBinding(),
     ),
     GetPage(
@@ -65,7 +65,7 @@ class AppPages {
       page: () {
         final controller = Get.find<WargaDashboardController>();
         controller.activeTabIndex.value = 1;
-        return const WargaView();
+        return WargaView();
       },
       binding: WargaBinding(),
     ),
@@ -74,7 +74,7 @@ class AppPages {
       page: () {
         final controller = Get.find<WargaDashboardController>();
         controller.activeTabIndex.value = 2;
-        return const WargaView();
+        return WargaView();
       },
       binding: WargaBinding(),
     ),
diff --git a/lib/app/services/supabase_service.dart b/lib/app/services/supabase_service.dart
index d901675..f51f102 100644
--- a/lib/app/services/supabase_service.dart
+++ b/lib/app/services/supabase_service.dart
@@ -423,22 +423,39 @@ class SupabaseService extends GetxService {
     }
   }
 
-  Future<int?> getTotalBantuan() async {
+  // Metode untuk mendapatkan data penerima terbaru
+  Future<List<Map<String, dynamic>>?> getPenerimaTerbaru() async {
     try {
-      final response = await client.from('stok_bantuan').select('jumlah');
+      final response = await client
+          .from('warga')
+          .select('*')
+          .eq('status', 'AKTIF')
+          .order('created_at', ascending: false)
+          .limit(5);
 
-      double total = 0;
-      for (var item in response) {
-        total += (item['jumlah'] ?? 0);
-      }
-
-      return total.toInt();
+      return response;
     } catch (e) {
-      print('Error getting total bantuan: $e');
+      print('Error getting penerima terbaru: $e');
       return null;
     }
   }
 
+  // Future<int?> getTotalBantuan() async {
+  //   try {
+  //     final response = await client.from('stok_bantuan').select('jumlah');
+
+  //     double total = 0;
+  //     for (var item in response) {
+  //       total += (item['jumlah'] ?? 0);
+  //     }
+
+  //     return total.toInt();
+  //   } catch (e) {
+  //     print('Error getting total bantuan: $e');
+  //     return null;
+  //   }
+  // }
+
   Future<int?> getTotalPenyaluran() async {
     try {
       final response = await client
@@ -453,6 +470,18 @@ class SupabaseService extends GetxService {
     }
   }
 
+  // Metode untuk mendapatkan total semua penyaluran (termasuk semua status)
+  Future<int?> getTotalSemuaPenyaluran() async {
+    try {
+      final response = await client.from('penyaluran_bantuan').select('id');
+
+      return response.length;
+    } catch (e) {
+      print('Error getting total semua penyaluran: $e');
+      return null;
+    }
+  }
+
   Future<List<Map<String, dynamic>>?> getNotifikasiBelumDibaca(
       String userId) async {
     try {
@@ -484,7 +513,13 @@ class SupabaseService extends GetxService {
 
       final response = await client
           .from('penyaluran_bantuan')
-          .select('*')
+          .select('''
+            *,
+            kategori_bantuan(*),
+            lokasi_penyaluran:lokasi_penyaluran_id(
+              id, nama, alamat_lengkap
+            )
+          ''')
           .gte('tanggal_penyaluran', todayUtc)
           .lt('tanggal_penyaluran', tomorrowUtc)
           .inFilter('status', ['AKTIF', 'DIJADWALKAN']);
@@ -713,6 +748,21 @@ class SupabaseService extends GetxService {
     }
   }
 
+  // Metode untuk mendapatkan total penitipan terverifikasi
+  Future<int?> getTotalPenitipanTerverifikasi() async {
+    try {
+      final response = await client
+          .from('penitipan_bantuan')
+          .select('id')
+          .eq('status', 'TERVERIFIKASI');
+
+      return response.length;
+    } catch (e) {
+      print('Error getting total penitipan terverifikasi: $e');
+      return null;
+    }
+  }
+
   // Metode untuk mengambil data penitipan bantuan dengan status TERVERIFIKASI
   Future<List<Map<String, dynamic>>?> getPenitipanBantuanTerverifikasi() async {
     try {
@@ -1109,11 +1159,31 @@ class SupabaseService extends GetxService {
   Future<List<Map<String, dynamic>>?> getPenyaluranBantuanByWargaId(
       String wargaId) async {
     try {
-      final response = await client
-          .from('penyaluran_bantuan')
-          .select('*, stok_bantuan:stok_bantuan_id(*)')
-          .eq('penerima_id', wargaId)
-          .order('tanggal_penyaluran', ascending: false);
+      // Pertama, cari warga berdasarkan NIP untuk mendapatkan UUID-nya
+      final wargaResponse = await client
+          .from('warga')
+          .select('id')
+          .eq('id', wargaId)
+          .maybeSingle();
+
+      if (wargaResponse == null) {
+        print('Warning: Warga dengan NIP $wargaId tidak ditemukan');
+        return [];
+      }
+
+      final wargaUuid = wargaResponse['id'];
+
+      // Kemudian gunakan UUID untuk mencari penyaluran bantuan
+      final response = await client.from('penerima_penyaluran').select('''
+            *,
+            penyaluran_bantuan:penyaluran_bantuan_id(
+              *,
+              kategori_bantuan(*),
+              lokasi_penyaluran:lokasi_penyaluran_id(
+                id, nama, alamat_lengkap
+              )
+            )
+          ''').eq('warga_id', wargaUuid).order('created_at', ascending: false);
 
       return response;
     } catch (e) {
@@ -1339,6 +1409,53 @@ class SupabaseService extends GetxService {
     }
   }
 
+  // Metode untuk memperbarui profil donatur
+  Future<void> updateDonaturProfile({
+    required String userId,
+    required String nama,
+    required String email,
+    String? noHp,
+    String? fotoProfil,
+  }) async {
+    try {
+      // Buat map untuk update data
+      final Map<String, dynamic> updateData = {
+        'nama': nama,
+        'nama_lengkap': nama, // Untuk konsistensi dengan field nama_lengkap
+        'no_hp': noHp,
+        'updated_at': DateTime.now().toIso8601String(),
+      };
+
+      // Tambahkan foto profil jika ada
+      if (fotoProfil != null) {
+        // Jika string kosong, set null untuk menghapus foto profil
+        if (fotoProfil.isEmpty) {
+          updateData['foto_profil'] = null;
+        } else {
+          updateData['foto_profil'] = fotoProfil;
+        }
+      }
+
+      // Update data donatur
+      await client.from('donatur').update(updateData).eq('id', userId);
+
+      // Update email di auth.users jika berubah
+      if (email != client.auth.currentUser?.email) {
+        // Gunakan metode updateUserEmail
+        await client.auth.updateUser(UserAttributes(
+          email: email,
+        ));
+      }
+
+      // Hapus cache user profile
+      _cachedUserProfile = null;
+      print('Cache profil user dihapus setelah update donatur');
+    } catch (e) {
+      print('Error updating donatur profile: $e');
+      throw e.toString();
+    }
+  }
+
   // Metode untuk membuat profil petugas desa
   Future<void> createPetugasDesaProfile({
     required String nama_lengkap,
@@ -1647,7 +1764,12 @@ class SupabaseService extends GetxService {
 
       // Tambahkan foto profil jika ada
       if (fotoProfil != null) {
-        updateData['foto_profil'] = fotoProfil;
+        // Jika string kosong, set null untuk menghapus foto profil
+        if (fotoProfil.isEmpty) {
+          updateData['foto_profil'] = null;
+        } else {
+          updateData['foto_profil'] = fotoProfil;
+        }
       }
 
       // Update data warga
@@ -1660,50 +1782,16 @@ class SupabaseService extends GetxService {
           email: email,
         ));
       }
+
+      // Hapus cache user profile
+      _cachedUserProfile = null;
+      print('Cache profil user dihapus setelah update warga');
     } catch (e) {
       print('Error updating warga profile: $e');
       throw e.toString();
     }
   }
 
-  // Metode untuk memperbarui profil donatur
-  Future<void> updateDonaturProfile({
-    required String userId,
-    required String nama,
-    required String email,
-    String? noHp,
-    String? fotoProfil,
-  }) async {
-    try {
-      // Buat map untuk update data
-      final Map<String, dynamic> updateData = {
-        'nama': nama,
-        'nama_lengkap': nama, // Untuk konsistensi dengan field nama_lengkap
-        'no_hp': noHp,
-        'updated_at': DateTime.now().toIso8601String(),
-      };
-
-      // Tambahkan foto profil jika ada
-      if (fotoProfil != null) {
-        updateData['foto_profil'] = fotoProfil;
-      }
-
-      // Update data donatur
-      await client.from('donatur').update(updateData).eq('id', userId);
-
-      // Update email di auth.users jika berubah
-      if (email != client.auth.currentUser?.email) {
-        // Gunakan metode updateUserEmail
-        await client.auth.updateUser(UserAttributes(
-          email: email,
-        ));
-      }
-    } catch (e) {
-      print('Error updating donatur profile: $e');
-      throw e.toString();
-    }
-  }
-
   // Metode untuk memperbarui profil petugas desa
   Future<void> updatePetugasDesaProfile({
     required String userId,
@@ -1722,7 +1810,12 @@ class SupabaseService extends GetxService {
 
       // Tambahkan foto profil jika ada
       if (fotoProfil != null) {
-        updateData['foto_profil'] = fotoProfil;
+        // Jika string kosong, set null untuk menghapus foto profil
+        if (fotoProfil.isEmpty) {
+          updateData['foto_profil'] = null;
+        } else {
+          updateData['foto_profil'] = fotoProfil;
+        }
       }
 
       // Update data petugas desa
@@ -1735,6 +1828,10 @@ class SupabaseService extends GetxService {
           email: email,
         ));
       }
+
+      // Hapus cache user profile
+      _cachedUserProfile = null;
+      print('Cache profil user dihapus setelah update petugas desa');
     } catch (e) {
       print('Error updating petugas desa profile: $e');
       throw e.toString();
diff --git a/lib/app/widgets/bantuan_card.dart b/lib/app/widgets/bantuan_card.dart
index f2ad70d..f11c779 100644
--- a/lib/app/widgets/bantuan_card.dart
+++ b/lib/app/widgets/bantuan_card.dart
@@ -105,7 +105,7 @@ class BantuanCard extends StatelessWidget {
                   crossAxisAlignment: CrossAxisAlignment.end,
                   children: [
                     StatusBadge(
-                      status: item.statusPenerimaan ?? 'MENUNGGU',
+                      status: item.statusPenerimaan ?? 'BELUMMENERIMA',
                       fontSize: 10,
                       padding: const EdgeInsets.symmetric(
                         horizontal: 8,
@@ -177,7 +177,7 @@ class BantuanCard extends StatelessWidget {
                     children: [
                       StatusBadge(status: item.statusPenyaluran ?? ""),
                       StatusBadge(
-                        status: item.statusPenerimaan ?? 'MENUNGGU',
+                        status: item.statusPenerimaan ?? 'BELUMMENERIMA',
                       ),
                     ],
                   ),
